(* Question 1.2 *)
type arbre_binaire = 
  Vide
| Noeud of arbre_binaire * int * arbre_binaire
    
let est_feuille = function
  | Noeud(Vide, _ , Vide) -> true
  | _ -> false

let est_noeud = function
  | Vide | Noeud(Vide, _ , Vide) -> false
  | _ -> true

let contenu_noeud = function
  | Vide -> -1
  | Noeud(_,i,_) -> i

let sous_arbre_gauche = function
  | Vide -> Vide
  | Noeud(fg,_,_) -> fg

let sous_arbre_droit = function
  | Vide -> Vide
  | Noeud(_,_,fd) -> fd

let faire_noeud fg i fd = 
  Noeud(fg,i,fd)

let faire_feuille i =
  Noeud(Vide,i,Vide)
