/* Question 1.3 */
#include <stdlib.h>
#include "ab.h"

struct donnee_arbre {
  int val;
  arbre_binaire fg;
  arbre_binaire fd;
};

int est_feuille(arbre_binaire a) {
  return (a && !a->fg && !a->fd);
}

int est_noeud(arbre_binaire a) {
  return (a && (a->fg || a->fd));
}

int contenu_noeud(arbre_binaire a) {
  if (a) return a->val;
  else return -1;
}

arbre_binaire sous_arbre_gauche(arbre_binaire a) {
  if (a) return a->fg;
  else return NULL;
}

arbre_binaire sous_arbre_droit(arbre_binaire a) {
  if (a) return a->fd;
  else return NULL;
}

arbre_binaire faire_noeud(arbre_binaire fg, int i, arbre_binaire fd) {
  arbre_binaire res = malloc(sizeof(struct donnee_arbre));
  res->val = i;
  res->fg = fg;
  res->fd = fd;
  return res;
}

arbre_binaire faire_feuille(int i) {
  return faire_noeud(NULL, i, NULL);
}
